<script src="../../bower_components/dezrannlib/index.js"></script>

<link rel="import" href="../../bower_components/polymer/polymer-element.html">
<link rel="import" href="../../bower_components/dez-music-canvas/dez-music-canvas.html">
<link rel="import" href="../../bower_components/dez-music-canvas/dez-label-editor.html">
<link rel="import" href="../../bower_components/dez-label-bar/dez-edit-bar.html">
<link rel="import" href="../../bower_components/app-layout/app-toolbar/app-toolbar.html">

<link rel="import" href="../../bower_components/neon-animation/animations/scale-up-animation.html">
<link rel="import" href="../../bower_components/app-route/app-location.html">

<link rel="import" href="../../bower_components/dez-corpus/dez-corpus.html">

<link rel="import" href="../../bower_components/dez-analysis/dez-analysis.html">
<link rel="import" href="../../bower_components/dez-debug/dez-debug.html">

<link rel="import" href="dez-about.html">
<link rel="import" href="dez-analysis-controls.html">
<link rel="import" href="dez-confirm-changes.html">
<link rel="import" href="dez-audio-player.html">
<link rel="import" href="dez-sources-selector.html">
<link rel="import" href="dez-piece-title.html">

<dom-module id="dezrann-app">
  <template>
    <style>

    :host {
        height: 100vh;
        display: flex;
        flex-direction: column;
    }

    dez-music-canvas {
        flex-grow: 1;
    }

    app-toolbar {
      background-color: #607D8B;
      color: #fff;
      font-family: 'Roboto', 'Noto', sans-serif;
    }

    dez-analysis-controls {
        min-width: 400px;
        flex: 1 0;
        align-self: center;
    }

    @media (max-width: 700px) {
      .hidden-xxs {
        display: none;
      }

      dez-analysis-controls {
        min-width: 240px;
      }
    }

    @media (max-width: 1024px) {
      .hidden-xs {
        display: none;
      }
    }

    @media (max-width: 1280px) {
      .hidden-md {
        display: none;
      }
    }

    </style>

    <app-location route="{{route}}" use-hash-as-path></app-location>

    <app-toolbar>

        <dez-corpus location="[[location]]" current="[[_pieceId]]" prefix="[[_prefix]]"></dez-corpus>
        <dez-about class="hidden-xs"></dez-about>
        <dez-piece-title class="hidden-xs" title=[[name]] composer=[[composer]]></dez-piece-title>

        <dez-analysis-controls
          id="analysisControls"
          piece-id=[[_pieceId]]
          piece-name=[[name]]
          location="[[_analysesLocation]]"
          collab-on="[[collabOn]]">
        </dez-analysis-controls>
        <dez-confirm-changes id="changesWillBeLostDialog" ></dez-confirm-changes>

        <dez-sources-selector id="sourcesSelector"></dez-sources-selector>

        <template is="dom-if" if=[[_audioVisible]] on-dom-change="_initAudio">
         <dez-audio-player id="audioPlayer" src="[[_audioFile]]"></dez-audio-player>
        </template>

    </app-toolbar>

    <dez-music-canvas
      id="analysisView"
      image="[[_imageLocation]]"
      positions-file="[[_positionsLocation]]"
      onset="{{_onset}}"
      type="{{_type}}"
      audio-synchro="[[_audioSynchro]]">
    </dez-music-canvas>

    <dez-analysis id="analysis"></dez-analysis>

    <template is="dom-if" if="[[labelBarOn]]" on-dom-change="_initRapidEditor">
      <dez-edit-bar id="editBar"></dez-edit-bar>
    </template>
    <template is="dom-if" if="[[!labelBarOn]]" on-dom-change="_initEditor">
      <dez-label-editor id="editor"></dez-label-editor>
    </template>

    <template is="dom-if" if=[[_debug]] on-dom-change="_initDebug">
        <dez-debug id="debug"></dez-debug>
    </template>

    <iron-ajax
        id="locationRequest"
        url="{{_pieceLocation}}"
        handle-as="json"
        auto
        on-response="_pieceInfosHandler">
    </iron-ajax>

  </template>

  <script>

  class DezrannApp extends Polymer.Element {

      static get is() { return 'dezrann-app'; }

      static get properties() {
          return {
              location : {
                type: String,
                observer: '_locationChanged'
              },
              labelBarOn : {
                type : Boolean,
                value : false
              },
              collabOn : {
                type : Boolean,
                value : false
              }
          }
      }

      static get observers() {
          return [
              '_routeChanged(route.*)'
          ]
      }

      _locationChanged () {
          let re = /http[s]?:\/\/[^/]*\/(.*)$/
          let match = re.exec(this.location)
          this._corpusLocalDir = "../../" + match[1] + "/"
      }

      async _pieceInfosHandler (event) {
          // Metadata
          let piece = event.detail.response
          this.name = piece.title;
          this.composer = piece.composer;
          this._timeSignature = piece['time-signature'];
          this._timeSignatureUpbeat = piece['time-signature-upbeat']
          if (!this.labelBarOn) {
            this.shadowRoot.querySelector('#editor').timeSignature = {
              numerator: parseInt(this._timeSignature.split('/')[0]) || 4,
              denominator: parseInt(this._timeSignature.split('/')[1]) || 4,
              upbeat: parseFloat(this._timeSignatureUpbeat) || 0
            }
          }
          document.title = this.name + ", " + this.composer + " - Dezrann"

          // remove cursor if it is displayed
          this.$.analysisView.currentDate = undefined

          let audios = piece.sources.audios
          if (audios && audios.length > 0) {
            this._audioVisible = true
            let dir = this._corpusLocalDir + this._pieceId
            this._audioFile = dir + "/" + audios[0].file
            this._audioSynchro = dir + "/" + audios[0]["onset-date"]
          } else {
            this._audioFile = undefined
            this._audioVisible = false
            this._audioSynchro = undefined
          }
          let images = piece.sources.images
          if (images && images.length > 0) {
            this._setSource(images[0])
          } else if (audios && audios[0].images) {
            this._setSource(audios[0].images[0])
          }
          this.$.sourcesSelector.sources = piece.sources
          this._analysesLocation = this._pieceLocation + "/analyses"
      }

      _setSource(source) {
          let dir = this._corpusLocalDir + this._pieceId
          this._type = source.type
          this._imageLocation = dir + "/" + source.image
          this._positionsLocation = dir + "/" + source.positions
      }

      async _routeChanged(event) {
          let re = /http[s]?:\/\/[^\/]+[\/]?([^#]*)[#]?([a-z]*)[\/]?([^#]*)[#]?([0-9]*)$/
          let match = re.exec(this.baseURI)
          let htmlFile = match[1] || ""
          let mode = match[2] || ""
          let id = match[3] || "bwv847"
          let onset = parseMeasureFrac(match[4] || '0')
          this._debug = mode == "debug"
          this._prefix = '/' + htmlFile + '#' + mode + '/'
          if (id != this._pieceId) {
              if (this.$.analysis.backupNeeded) {
                  this.set('route.path', this._debug?"debug":"" + "/" + this._pieceId + "#" + toMeasureRounded(this._onset));
                  this._actionToConfirm = "CHANGE_PIECE"
                  this._wantedPieceId = id
                  this.$.changesWillBeLostDialog.open();
              } else {
                  await this._changePiece(id)
              }
          }
          if (this._onset == undefined || Math.abs(onset - this._onset) > 6) {
              this._onset = onset;
          }
      }

      _confirmAction () {
          if (this._actionToConfirm == "CHANGE_PIECE") {
              this._changePiece(this._wantedPieceId)
              this.set('route.path', this._debug?"debug":"" + "/" + this._wantedPieceId + "#" + toMeasureRounded(this._onset));
          }
          this.$.analysis.backupNeeded = false;
      }

      async _changePiece (id) {
          this.$.analysisView.removeAnalysis();
          this.$.analysisView.removePositions();
          this._pieceId = id;
          this._pieceLocation = this.location + "/" + this._pieceId;
      }

      async ready () {
          super.ready();
          this.$.analysisView.addEventListener('onset-changed', e => {
              let debugKey = this._debug?"debug":"";
              this.set('route.path', debugKey + "/" + this._pieceId + "#" + toMeasureRounded(this._onset));
          })

          this.$.changesWillBeLostDialog.addEventListener(
            'action-confirmed',
            event => this._confirmAction()
          )

          this.$.sourcesSelector.addEventListener('new-source-selected', event => {
            this._setSource(event.detail.source)
          })

          this.$.analysisView.analysis = this.$.analysis
          this.$.analysisControls.analysis = this.$.analysis
          this.$.analysisControls.confirmDialog = this.$.changesWillBeLostDialog
      }

      _initRapidEditor () {
        let editBar = this.shadowRoot.querySelector('#editBar')
        let analysis =  this.$.analysis
        let labelTypes = analysis.labelTypes
        let initTagsNames = ["Refrain", "Couplet", "Voix aiguës"]
        labelTypes.neededTags = initTagsNames
        editBar.tags = initTagsNames.map(tag => labelTypes.coloredTag(tag, "Edmus"))
        editBar.activeTag = editBar.tags[0].name

        analysis.addEventListener('analysis-loaded', () => {
          let usedTags = analysis.usedTags
          if (usedTags.length > 0) {
            let names = usedTags.sort((a,b) => b.occurences - a.occurences)
            .slice(0,10)
            .map(tag => tag.name)
            editBar.tags = names.map(name => labelTypes.coloredTag(name, "Edmus"))
            editBar.activeTag = editBar.tags[0].name
            labelTypes.neededTags = names
          }
        })

        analysis.addEventListener('label-selected', event => {
          editBar.activeTag = event.detail.label.tag
          editBar.selectedInput = event.detail.label.tag
        })

        editBar.addEventListener('tags-list-changed', (event) => {
          let names = event.detail.names
          labelTypes.neededTags = names
          // add new tags
          names.filter(
            name => editBar.tags.filter(tag => tag.name == name).length == 0
          ).forEach(name => editBar.tags.push(labelTypes.coloredTag(name, "Edmus")))
          // delete tags
          editBar.tags = editBar.tags.filter(tag => names.includes(tag.name))
        })

        editBar.addEventListener('tag-btn-tap', () => {
          let tag = editBar.activeTag
          let model = {
            type: 'Edmus',
            tag: tag,
            color: labelTypes.colorOfType({ type: "Edmus", tag: tag }).hex
          }
          analysis.currentLabelModel = model
          if (this._audioPlayer && this._audioPlayer.playing) {
            let onset = this.$.analysisView.synchro.toOnset(this._audioPlayer.currentTime)
            analysis.addLabel (Object.assign(model, { duration : 3, start : onset }))
          }
        })

        editBar.addEventListener('plus-btn-tap', () => {
          editBar.tags.push(labelTypes.coloredTag(editBar.selectedInput, "Edmus"))
          editBar.tags = editBar.tags.filter(v=>true)
        })

        editBar.addEventListener('selected-input-changed', () => {
          if (editBar.selectedInput != undefined) {
            analysis.setLabel({
              'id': analysis.selectedLabel.id,
              'tag': editBar.selectedInput
            })
          }
        })
      }

      _initAudio () {
        let audioPlayer = this.shadowRoot.querySelector('#audioPlayer')
        audioPlayer.addEventListener('new-step-forward', () => {
          this.$.analysisView.currentDate = audioPlayer.currentTime
          let onset = this.$.analysisView.synchro.toOnset(audioPlayer.currentTime)
          audioPlayer.currentMeasure = 'm' + toMeasureRounded(onset)
        })
        audioPlayer.addEventListener('rewind-pressed', () => {
          this.$.analysisView.currentDate = 0
        })
        this.$.analysisView.addEventListener('current-date-changed', event => {
          audioPlayer.currentTime = this.$.analysisView.currentDate
          this._audioPlayer.currentTime = this.$.analysisView.currentDate
        })
        this._audioPlayer = audioPlayer
      }

      _initEditor () {
        this.shadowRoot.querySelector('#editor').analysis = this.$.analysis
      }

      _initDebug () {
        this.shadowRoot.querySelector('#debug').analysis = this.$.analysis
      }

  }

  window.customElements.define(DezrannApp.is, DezrannApp);

  </script>
</dom-module>
